package com.google.p.client;

import android.app.Activity;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.ServiceConnection;
import android.os.Bundle;
import android.os.IBinder;
import android.os.RemoteException;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

import com.google.p.server.IMyService;

public class AIDLClient extends Activity {
	public ServiceConnection conn=null;
    private int statusValue = 0;
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        Button startButton = (Button) findViewById(R.id.startButton);
        Button stopButton = (Button)findViewById(R.id.stopButton);
        startButton.setOnClickListener(new OnClickListener() {
            public void onClick(View v) {
            	Log.i("knight","ServiceClient: Start Button Clicked");
            	// 1.  ̸  . (Ŭ ̸ 𸦶)
            	// ͸   ִ.  manifest.xml service -> intent-filter -> action ־ Ѵ. 
            	Intent i = new Intent("com.google.p.server.REMOTE_SERVICE");
            	// 2. Ŭ ̸ ˰  . 
//            	Intent i = new Intent(IMyService.class.getName());
   				bindService(i,conn, Context.BIND_AUTO_CREATE);
   			}
        });
        
        stopButton.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				Log.i("knight","ServiceClient: Stop Button Clicked");
				unbindService(conn);
			}
		});
        
        conn=new ServiceConnection() {
        	public void onServiceConnected(ComponentName name, IBinder service){
        		Log.i("knight", "ServiceClient: Remote Service Connected!!");     		
        		
        		IMyService myService = IMyService.Stub.asInterface(service);
        		try {
					statusValue = myService.getStatus();
	        		Log.i("knight", "ServiceClient: Remote Service Bind     "+statusValue);
	        		Log.i("knight", "ServiceClient: ComponentName   "+name);
				} catch (RemoteException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
        	}
        	public void onServiceDisconnected(ComponentName name){
        		Log.i("knight", "Service UnBind");
        	}
        };
    }
}